//==========================================================
//== 	Title: UsefulEvents
//== 	Author: Clay Hanson
//== 	11:02 AM 7/16/2016
//==========================================================
//Keypad
registerOutputEvent(fxDTSBrick,keypad_resetKeypadCode,"",0);
registerOutputEvent(fxDTSBrick,keypad_enterKeypadCode,"string 1 20",1);
registerOutputEvent(fxDTSBrick,keypad_setCorrectKeypadCode,"string 100 150",1);
registerOutputEvent(fxDTSBrick,keypad_checkKeypadCode,"",1);
registerInputEvent("fxDTSBrick","onKeypadCorrect","Self fxDTSBrick	Player Player	Client GameConnection");
registerInputEvent("fxDTSBrick","onKeypadIncorrect","Self fxDTSBrick	Player Player	Client GameConnection");
registerInputEvent("fxDTSBrick","onKeypadFull","Self fxDTSBrick	Player Player	Client GameConnection");
function fxDTSBrick::keypad_resetKeypadCode(%this) {
	%this.playSound(beep_key_sound.getID());
	%this.keypadCode = "";
}
function fxDTSBrick::keypad_enterKeypadCode(%this,%number,%client) {
	%this.playSound(beep_key_sound.getID());
	if(%this.correctKeypadCode $= "") {
		messageClient(%client,'',"\c6This brick\'s keypad code is not set.");
		return;
	}

	if(strLen(%this.keypadCode) <= strLen(%this.correctKeypadCode))
		%this.keypadCode = %this.keypadCode@%number;
	else
		%this.onKeypadFull(%client);
}
function fxDTSBrick::keypad_setCorrectKeypadCode(%this,%number,%client) {
	%this.correctKeypadCode = %number;
	messageClient(%client,'',"\c6Set this brick\'s keypad code to \c2"@%number@"\c6.");
}
function fxDTSBrick::keypad_checkKeypadCode(%this,%client) {
	%this.playSound(beep_key_sound.getID());
	if(%this.keypadCode == %this.correctKeypadCode)
		%this.onKeypadCorrect(%client);
	else
		%this.onKeypadIncorrect(%client);
}
function fxDTSBrick::onKeypadCorrect(%obj, %client) {
	%obj.keypad_resetKeypadCode(%client);
	$InputTarget_["Self"] = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onKeypadCorrect",%client);
}
function fxDTSBrick::onKeypadFull(%obj, %client) {
	%obj.playSound(Beep_TryAgain_Sound.getID());
	$InputTarget_["Self"] = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onKeypadFull",%client);
}
function fxDTSBrick::onKeypadIncorrect(%obj, %client) {
	%obj.playSound(Beep_TryAgain_Sound.getID());
	%obj.keypad_resetKeypadCode(%client);
	$InputTarget_["Self"] = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onKeypadIncorrect",%client);
}
//Checkforinfo
registerOutputEvent(fxDTSBrick,checkForInfo,"list BLID 0 Name 1 Score 2	string 100 150",1);
registerInputEvent("fxDTSBrick","onInfoMismatch","Self fxDTSBrick	Player Player	Client GameConnection");
registerInputEvent("fxDTSBrick","onInfoMatch","Self fxDTSBrick	Player Player	Client GameConnection");
function fxDTSBrick::checkForInfo(%this,%a,%b,%client) {
	switch(%a) {
		case 0:
			if(%client.bl_id == %b)
				%this.onInfoMatch(%client);
			else
				%this.onInfoMismatch(%client);
		case 1:
			if(%client.name $= %b)
				%this.onInfoMatch(%client);
			else
				%this.onInfoMismatch(%client);
		case 2:
			if(%client.score == %b)
				%this.onInfoMatch(%client);
			else
				%this.onInfoMismatch(%client);
	}
		
}
function fxDTSBrick::onInfoMismatch(%obj, %client) {
	$InputTarget_["Self"] = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onInfoMismatch",%client);
}
function fxDTSBrick::onInfoMatch(%obj, %client) {
	$InputTarget_["Self"] = %obj;
	$InputTarget_["Player"] = %client.player;
	$InputTarget_["Client"] = %client;
	%obj.processInputEvent("onInfoMatch",%client);
}